<?php

add_action('admin_menu', 'bildbyran_images_add_settings_menu');
function bildbyran_images_add_settings_menu() {
    add_options_page(__('Bildbyr&aring;n settings', 'bildbyran_images'), __('Bildbyr&aring;n', 'bildbyran_images'), 'manage_options', 'bildbyran_images_settings', 'bildbyran_images_settings_page');
    add_action('admin_init', 'register_bildbyran_images_options');
}


function register_bildbyran_images_options(){
    register_setting('bildbyran_images_options', 'bildbyran_images_options', 'bildbyran_images_options_validate');
    add_settings_section('bildbyran_images_options_section', '', '', 'bildbyran_images_settings');
    add_settings_field('apikey', __('API-key', 'bildbyran_images'), 'bildbyran_images_render_apikey', 'bildbyran_images_settings', 'bildbyran_images_options_section');
    add_settings_field('attribution-id', __('Byline', 'bildbyran_images'), 'bildbyran_images_render_attribution', 'bildbyran_images_settings', 'bildbyran_images_options_section');
    add_settings_field('caption-id', __('Caption', 'bildbyran_images'), 'bildbyran_images_render_caption', 'bildbyran_images_settings', 'bildbyran_images_options_section');
    add_settings_field('photo-size', __('Photo Size', 'bildbyran_images'), 'bildbyran_images_photo_size', 'bildbyran_images_settings', 'bildbyran_images_options_section');
    add_settings_field('button-id', __('Button', 'bildbyran_images'), 'bildbyran_images_render_button', 'bildbyran_images_settings', 'bildbyran_images_options_section');
}


function bildbyran_images_render_attribution(){
    $options = get_option('bildbyran_images_options');
    echo '<label><input name="bildbyran_images_options[attribution]" value="true" type="checkbox"'.(!$options['attribution'] | $options['attribution']=='true'?' checked="checked"':'').'> '.__('Insert image byline', 'bildbyran_images').'</label>';
}

function bildbyran_images_render_caption(){
    $options = get_option('bildbyran_images_options');
    echo '<label><input name="bildbyran_images_options[caption]" value="true" type="checkbox"'.(!$options['caption'] | $options['caption']=='true'?' checked="checked"':'').'> '.__('Insert image caption', 'bildbyran_images').'</label>';
}

function bildbyran_images_photo_size(){
    $options = get_option('bildbyran_images_options');
    echo '<label><input name="bildbyran_images_options[photo-size]" value="true" type="checkbox"'.(!$options['photo-size'] | $options['photo-size']=='true'?' checked="checked"':'').'> '.__('Download high-res images (unchecked = 1920x1280)', 'bildbyran_images').'</label>';
}

function bildbyran_images_render_button(){
    $options = get_option('bildbyran_images_options');
    echo '<label><input name="bildbyran_images_options[button]" value="true" type="checkbox"'.(!$options['button'] | $options['button']=='true'?' checked="checked"':'').'> '.__('Show Bildbyr&aring;n button next to "Add Media"', 'bildbyran_images').'</label>';
}

function bildbyran_images_render_apikey(){
    $options = get_option('bildbyran_images_options');
    echo '<label><input type="text" name="bildbyran_images_options[apikey]" value="'.$options['apikey'].'"> '.__('Enter your API-key', 'bildbyran_images').'</label>';
}



function bildbyran_images_settings_page() { ?>
    <div class="wrap">
    <h2><?= _e('Bildbyr&aring;n settings', 'bildbyran_images'); ?></h2>
    <form method="post" action="options.php">
        <?php
            settings_fields('bildbyran_images_options');
            do_settings_sections('bildbyran_images_settings');
            submit_button();
        ?>
    </form>
    <hr style="margin-bottom:20px">
    <p>
        Official <a href="https://www.bildbyran.se/"><img src="<?= plugin_dir_url(__FILE__).'img/logo.png' ?>" style="width:120px;margin:0 5px;position:relative;top:5px"></a> plugin by 
        Bildbyr&aring;n<br>Based on <a href="https://www.wordpress.org/plugins/pixabay-images/">Pixabay Images plugin</a> by Simon Steinberger</a> and Emilian Robert Vicol.
    </p>
    <p>Find us on <a href="https://www.facebook.com/bildbyran">Facebook</a> and <a href="https://twitter.com/bildbyran">Twitter</a>.</p>
    </div>
<?php }


function bildbyran_images_options_validate($input){
    $options = get_option('bildbyran_images_options');
    if ($input['attribution']) $options['attribution'] = 'true'; else $options['attribution'] = 'false';
    if ($input['caption']) $options['caption'] = 'true'; else $options['caption'] = 'false';
    if ($input['button']) $options['button'] = 'true'; else $options['button'] = 'false';
    if ($input['photo-size']) $options['photo-size'] = 'true'; else $options['photo-size'] = 'false';
    $options['apikey'] = $input['apikey'];
    return $options;
}
?>
